// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package model

import (
	"github.com/jinzhu/gorm"
	"time"
)

type TStaff struct {
	Id int64 `gorm:"column:ID;PRIMARY_KEY" json:"id"`
	Code string `gorm:"column:Code" json:"code"`
	CorpCode string `gorm:"column:CorpCode" json:"corp_code"`
	CorpName string `gorm:"column:CorpName" json:"corp_name"`
	TeamSysNo int `gorm:"column:TeamSysNo" json:"team_sys_no"`
	TeamName string `gorm:"column:TeamName" json:"team_name"`
	WorkName string `gorm:"column:WorkName" json:"work_name"`
	IsTeamLeader string `gorm:"column:IsTeamLeader" json:"is_team_leader"`
	IDCardType int `gorm:"column:IDCardType" json:"id_card_type"`
	IDCardNumber string `gorm:"column:IDCardNumber" json:"id_card_number"`
	Age int `gorm:"column:Age" json:"age"`
	Gender string `gorm:"column:Gender" json:"gender"`
	Nation string `gorm:"column:Nation" json:"nation"`
	Address string `gorm:"column:Address" json:"address"`
	HeadImage string `gorm:"column:HeadImage" json:"head_image"`
	PoliticsType int `gorm:"column:PoliticsType" json:"politics_type"`
	CultureLevelType int `gorm:"column:CultureLevelType" json:"colture_level_type"`
	GrantOrg string `gorm:"column:GrantOrg" json:"grant_org"`
	WorkType string `gorm:"column:WorkType" json:"work_type"`
	NativePlace string `gorm:"column:NativePlace" json:"native_place"`
	Mobile string `gorm:"column:Mobile" json:"mobile"`
	IssueCardPicUrl string `gorm:"column:IssueCardPicUrl" json:"issue_card_pic_url"`
	HasContract string `gorm:"column:HasContract" json:"has_contract"`
	HasBuyInsurance string `gorm:"column:HasBuyInsurance" json:"has_buy_insurance"`
	Remark string `gorm:"column:Remark" json:"remark"`
	ProjectId int64 `gorm:"column:ProjectId" json:"project_id"`
	WorkNo string `gorm:"column:WorkNo" json:"work_no"`
	Sn string `gorm:"column:Sn" json:"sn"`
	CreatedAt time.Time `gorm:"column:CreatedAt" json:"created_at"`
	UpdatedAt time.Time `gorm:"column:UpdatedAt" json:"updated_at"`
}


func (TStaff) TableName() string {
	return "db_smart_attendance.ProjectWorkInfo"
}

func (p *TStaff) Insert(db *gorm.DB) error {
	return db.Table(p.TableName()).Create(p).Error
}


func (p *TStaff) Del(db *gorm.DB, where map[string]interface{}) error {
	cond, val, err := whereBuild(where)
	if err != nil {
		return err
	}
	return db.Table(p.TableName()).Where(cond, val...).Delete(p).Error
}

func (p *TStaff) Find(db *gorm.DB, where map[string]interface{}) error {
	cond, val, err := whereBuild(where)
	if err != nil {
		return err
	}
	return db.Table(p.TableName()).Where(cond, val...).First(p).Error
}

func (p *TStaff) Update(db *gorm.DB, where map[string]interface{}, values map[string]interface{}) error {
	cond, val, err := whereBuild(where)
	if err != nil {
		return err
	}

	return db.Table(p.TableName()).Where(cond, val...).Updates(values).Error
}


func (p *TStaff) Save(db *gorm.DB) error {
	return db.Save(p).Error
}

func (p *TStaff) Count(db *gorm.DB, where map[string]interface{}) (int64, error) {
	if len(where) > 0 {
		cond, val, err := whereBuild(where)
		if err != nil {
			return 0, err
		}
		ret := int64(0)
		err = db.Table(p.TableName()).Where(cond, val...).Count(&ret).Error

		return ret, err
	}
	ret := int64(0)
	err := db.Table(p.TableName()).Count(&ret).Error
	return ret, err
}

func (p *TStaff) List(db *gorm.DB, where map[string]interface{}, page int) (list []TStaff, err error) {
	if len(where) > 0 {
		cond, val, err := whereBuild(where)
		if err != nil {
			return list, err
		}

		result := db.Table(p.TableName()).Where(cond, val...).Limit(PageSize).Offset(page).Find(&list)

		return list, result.Error
	}
	result := db.Table(p.TableName()).Limit(10).Offset(page).Find(&list)

	return list, result.Error

}

func (p *TStaff) All(db *gorm.DB) (list []TStaff, err error) {

	result := db.Table(p.TableName()).Find(&list)

	return list, result.Error
}
